#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "widgets.h"

static struct wgt_window *win;
static struct wgt_widget *lb_instto, *bn_inst, *bn_cancel, *cb_devs, *ck_usbonly;

static void onclick(struct wgt_widget *w);
static void onmodify(struct wgt_widget *w);

int WINAPI WinMain(HINSTANCE hinst, HINSTANCE hprevinst, char *cmdline, int showcmd)
{
	int x, y;
	MSG msg;
	static const char *items[] = {
		"item one",
		"item two",
		"item three"
	};


	if(!(win = wgt_window("256boss USB stick installer", 400, 300))) {
		return 1;
	}
	lb_instto = wgt_label(win, "Install to device:", 10, 10);

	x = wgt_xpos_after(lb_instto, WGT_AUTO);
	cb_devs = wgt_combo(win, items, sizeof items / sizeof *items, 0,
			x, 10, WGT_AUTO, WGT_AUTO, onmodify);

	y = wgt_ypos_after(cb_devs, 16);
	ck_usbonly = wgt_checkbox(win, "only show USB devices", 1, x, y,
			WGT_AUTO, WGT_AUTO, 0);

	y = wgt_ypos_after(ck_usbonly, 16);
	bn_inst = wgt_button(win, "Install", 10, y, WGT_AUTO, WGT_AUTO, onclick);

	x = wgt_xpos_after(bn_inst, WGT_AUTO);
	bn_cancel = wgt_button(win, "Cancel", x, y, WGT_AUTO, WGT_AUTO, onclick);

	while(GetMessage(&msg, 0, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	wgt_destroy_window(win);
	return 0;
}

static void onclick(struct wgt_widget *w)
{
	MessageBox(0, "clicked", "clicked", MB_OK);
}

static void onmodify(struct wgt_widget *w)
{
	int sel = wgt_combo_selected(w);
	if(sel >= 0) {
		const char *selstr = wgt_get_combo_item(w, sel);
		MessageBox(0, selstr, "selected item", MB_OK);
	}
}